update-alternatives(8)

NAMN
update-alternatives - underhåller symboliska länkar för att bestämma standardkommandon

SYNOPS
update-alternatives [flaggor] åtgärd

BESKRIVNING
update-alternatives skapar, tar bort, underhåller och visar information om de symboliska länkar som ingår i Debians alternativsystem.

Det är möjligt för flera kommandon som tillhandahåller identisk eller liknande funktionalitet att vara installerade på ett system samtidigt. Till exempel har många system flera textredigeringsprogram installerade samtidigt, vilket ger användarna på systemet valmöjligheter, var och en kan använda olika textredigeringsprogram om de så önskar, men det gör det svårt för ett program att göra ett bra val av textredigerare att anropa om en användare inte har gjort ett specifikt val.

Debians alternativsystem försöker lösa detta problem. Ett generiskt namn i filsystemet delas av alla filer som tillhandahåller utbytbar funktionalitet. Alternativsystemet och systemadministratören anger tillsammans vilken specifik fil som skall refereras av sitt generiska namn. Till exempel kan alternativsystemet låta det generiska namnet /usr/bin/editor att peka mot /usr/bin/nvi som standard om både textredigeringsprogrammet ed(1) och nvi(1) båda är installerade på systemet. Systemadministratören kan överstyra detta och låta det peka på /usr/bin/ed istället, och alternativsystemet kommer inte ändra denna inställning förrän det ombeds att göra det.

Det generiska namnet är inte en direkt symbolisk länk till det valda alternativet. Istället är det en symbolisk länk till ett namn i katalogen alternatives, vilket i sin tur är en symbolisk länk till den faktiska fil det pekar mot. Detta görs så att systemadministratörens ändringar kan begränsas till katalogen /etc: FHS (se detta) ger orsaker till varför detta är Bra.

När ett paket som tillhandahåller en fil med en specifik funktionalitet installeras, ändras eller tas bort, anropas update-alternatives för att uppdatera information om filen i alternativsystemet. update-alternatives anropas normalt från postinst- eller prerm-skripten i Debianpaket.

Det är ofta lämpligt för ett antal alternativ att vara synkroniserade, så att de ändras i grupp. Till exempel, om det är flera versioner av textredigeraren vi(1) installerade bör manualsidan som refereras till av /usr/share/man/man1/vi.1 motsvara den binär som refereras till av /usr/bin/vi. update-alternatives hanterar detta genom huvud- och slav-länkar. När huvudlänken uppdateras ändras även anslutna slavlänkar. En huvudlänk och dess anslutna slavar utgör en länkgrupp.

En länkgrupp kan vid varje given tidpunkt vara i ett av två lägen: automatisk eller manuell. När en grupp är i automatiskt läge kommer alternativsystemet automatiskt att bestämma när och hur länkar skall uppdateras då paket installeras eller tas bort. I manuellt läge kommer alternativsystemet inte att ändra länkarna, utan lämnar alla beslut till systemadministratören.

Länkgrupper är i automatiskt läge när de först introduceras på systemet. Om systemadministratören gör ändringar till systemets automatiska inställningar kommer detta att noteras nästa gång update-alternatives körs på den ändrade länkens grupp och gruppen kommer automatiskt att växlas till manuellt läge.

Varje alternativ har en prioritet kopplad till sig. När en länkgrupp är i automatiskt läge kommer det alternativ som medlemmar i gruppen pekar mot vara den med den högsta prioriteten.

När flaggan --config används kommer update-alternatives att visa alla val för länkgruppen där namn är huvudlänken. Det aktuella valet är markerat med en "*" och valet med högsta prioritet med ett "+". Du kommer därefter att få välja vad som skall göras med länkgruppen. När du har gjort en ändring kommer länkgruppen inte längre att vara i auto-läge. Du måste använda flaggan --auto för att återgå till automatiskt läge.

Om du vill konfigurera icke-interaktivt kan du använda flaggan --set i stället (se nedan).

Olika paket som tillhandahåller samma fil måste göra så i samförstånd. Det betyder att det är ett krav att alla involverade paket använder sig av update-alternatives. Det är inte möjligt att överstyra en fil ett paket som inte använder update-alternatives-mekanismen.

TERMINOLOGI
Efter update-alternatives aktiviteter är ganska komplexa blir det enklare att förstå hur det fungerar genom att vi förklarar några specifika termer.

generiskt namn
    Ett namn, till exempel /usr/bin/editor, som via alternativsystemet pekar på en av flera filer med liknande funktionalitet.

symbolisk länk
    Utan ytterligare beskrivning menas en symbolisk länk i alternativkatalogen: en som systemadministratören förväntas justera.

alternativ
    Namnet på en specifik fil i filsystemet, som kan vara tillgänglig via ett generiskt namn med hjälp av alternativsystemet.

alternativkatalogen
    En katalog, som standard /etc/alternatives, som innehåller de symboliska länkarna.

administrativ katalog
    En katalog, som standard /var/lib/dpkg/alternatives, som innehåller tillståndsinformation för update-alternatives.

länkgrupp
    En uppsättning relaterade symboliska länkar, avsedda att uppdateras som en grupp.

huvudlänk
    Länken i en länkgrupp som bestämmer hur de andra länkarna i gruppen ställs in.

slavlänk
    En länk i en länkgrupp som styrs av hur huvudlänken ställs in.

automatiskt läge
    När en länkgrupp är i automatiskt läge försäkrar alternativsystemet att länkarna i gruppen pekar på det högstprioriterade alternativet som är lämpligt för gruppen.

manuellt läge
    När en grupp är i manuellt läge kommer inte alternativsystemet att utföra några ändringar till systemadministratörens inställningar.

KOMMANDON

--install gennamn symlänk altern prioritet [--slave gennamn symlänk altern]...
    Lägg till en grupp med alternativ till systemet. gennamn är det generiska namnet för huvudlänken, symlänk är namnet på dess symboliska länk i alternativkatalogen och altern är alternativet som introduceras för huvudlänken. Argumenten efter --slave är det generiska namnet, namnet på den symboliska länken i alternativkatalogen och alternativet för slavlänken. Noll eller flera --slave-flaggor kan anges, där alla följs av tre argument.

    Om den huvudsakliga symboliska länken redan finns i alternativsystemets databas kommer informationen som anges att läggas in som en ny uppsättning av alternativ för gruppen. Om inte kommer en ny grupp, inställd på automatiskt läge, att läggas till med given information. Om gruppen är i automatiskt läge och det alternativ som läggs in har högre prioritet än alla andra installerade alternativ för gruppen kommer de symboliska länkarna att uppdateras så att de pekar på de nyligen tillagda alternativen.

--set namn sökväg
    Sätt programmet sökväg som ett alternativ till namn. Detta motsvarar --config men är icke-interaktivt och kan därmed användas i ett skript.

--remove namn sökväg
    Ta bort ett alternativ och alla dess anknutna slavlänkar. namn är ett namn i alternativkatalogen och sökväg är ett absolut filnamn till vilket namn kunde länkas. Om namn faktiskt är länkat till sökväg kommer namn att uppdateras till att peka på ett annat lämpligt alternativ, eller att tas bort om det inte finns något alternativ kvar. Anknutna slavlänkar kommer uppdateras eller tas bort på motsvarande vis. Om länken inte för tillfället pekar på sökväg kommer inga länkar att uppdateras utan bara informationen om alternativet att tas bort.

--remove-all namn
    Tar bort alla alternativ och alla deras anslutna slavlänkar. namn är ett namn i alternativkatalogen.

--all
    Anropa --config på alla alternativ.

--auto länk
    Ställ in den huvudsakliga symboliska länken till automatiskt läge. Detta får till följd att den symboliska länken och dess slavar uppdateras till att peka på det högst prioriterade installerade alternativet.

--display länk
    Visa information om länkgruppen i vilken länk är huvudlänken. Information som visas är gruppens läge (automatiskt eller manuellt), vilket alternativ den symboliska länken just nu pekar på, vilka andra alternativ som är tillgängliga (och deras motsvarande slavalternativ), samt det högst prioriterade alternativ som för närvarande är installerat.

--list länk
    Visar alla mål för länkgruppen.

--config länk
    Visa tillgängliga alternativ för en länkgrupp och låt användaren att interaktivt välja vilken som skall användas. Länkgruppen uppdateras och tas ut ur det automatiska läget.

--help
    Visar hjälpskärm och avslutar.

--version
    Visar version och avslutar.

FLAGGOR

--altdir katalog
    Anger alternativkatalogen om detta inte skall vara standardvärdet.

--admindir katalog
    Anger den administrativa katalogen om detta inte skall vara standardvärdet.

--verbose
    Visa fler kommentarer om vad update-alternatives gör.

--quiet
    Skriv inte några kommentarer såvida det inte uppstår ett fel. Denna flagga har ännu inte implementerats.

FILER

/etc/alternatives/
    Den förvalda alternativkatalogen. Kan överstyras med flaggan --altdir.

/var/lib/dpkg/alternatives/
    Den förvalda administrativa katalogen. Kan överstyras med flaggan --admindir.

RETURVÄRDE

0   Den önskade funktionen utfördes utan fel.

2   Problem uppstod vid tolkning av kommandoraden eller när funktionen skulle utföras.

DIAGNOSTIK
update-alternatives beskriver i det oändliga vad det gör på dess standard ut-kanal. Om ett fel uppstår skriver update-alternatives ut felmeddelanden på sin standard fel-kanal och avslutar med felkoden 2. Denna diagnostik bör vara självförklarande, sänd in en felrapport om du inte tycker att den är det.

EXEMPEL
Det är flera paket som tillhandahåller en textredigerare kompatibel med vi, till exempel nvi och vim. Vilken bestäms via länkgruppen vi, vilken innehåller länkar både för själva programmet och dessa anknutna manualsida.

För att visa vilka tillgängliga paket som tillhandahåller vi, samt dess aktuella inställning, använd kommandot --display:

    update-alternatives --display vi

För att välja en specifik implementation av vi, utför detta kommando som root och välj sedan ett tal från listan:

    update-alternatives --config vi

För att återgå till att vi-implementationen väljs automatiskt, utför detta som root:

    update-alternatives --auto vi

PROGRAMFEL
Om du hittar ett fel ber vi dig rapportera det via Debians felrapporteringssystem, eller, om det inte är möjligt, sända e-post direkt till författaren.

Om du hittar några diskrepanser mellan vad update-alternatives gör och vad som står i manualsidan så är detta ett fel, antingen i implementationen eller i dokumentationen; rapportera det.

FÖRFATTARE
Upphovsrättsskyddad © 1995 Ian Jackson.

Detta är fri programvara; se GNU General Public License version 2 eller senare för kopieringsvillkor. Det finns INGEN GARANTI.

Manualsidan är upphovsrättsskyddad © 1997,1998 Charles Briscoe-Smith.

Detta är fri programvara; se GNU General Public License version 2 eller senare för kopieringsvillkor. Det finns INGEN GARANTI.

SE ÄVEN
ln(1), FHS, Filesystem Hierarchy Standard.

ÖVERSÄTTNING
Peter Krefting och Daniel Nylander.